#include <NewPing.h>

#define TRIGGER_PIN 12
#define ECHO_PIN 11
#define MAX_DISTANCE 200
 
NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE);

void setup() {
  for(int x = 0; x < 11; x++) {
    pinMode(x, OUTPUT);
    digitalWrite(x, HIGH);
    delay(50);
  }

  for(int x = 10; x >= 0; x--) {
    digitalWrite(x, LOW);
    delay(50);
  }

  Serial.begin(9600);
}

void loop() {
  unsigned int distance = sonar.ping_median(5);
  distance = sonar.convert_cm(distance);
  setLeds(distance, 10, 100);
}

void setLeds(unsigned int distance, unsigned int minDist, unsigned int maxDist) {
  int leds;
  static bool isTooFar = true;
  
  leds = map(distance, minDist, maxDist, 9, 0);
  if(distance <= minDist) leds = 10;
  if(distance == 0 && isTooFar) leds = 0;
  
  for(int x = 0; x < 11; x++) {
    digitalWrite(x, x <= leds);
  }
  
  if(distance > 0) {
    if(distance >= maxDist)
      isTooFar = true;
    else
      isTooFar = false;
  }
}
